2016-08-06 11:17:56 +00:00
#### MINIMAL-FUNCTION-SET BEGIN ####
2016-11-22 17:18:35 +00:00
## FUNC_BUILD=2016112203
2016-08-28 09:32:25 +00:00
## BEGIN Generic bash functions written in 2013-2016 by Orsiris de Jong - http://www.netpower.fr - ozy@netpower.fr
## To use in a program, define the following variables:
## PROGRAM=program-name
## INSTANCE_ID=program-instance-name
## _DEBUG=yes/no
2016-11-17 19:00:23 +00:00
## _LOGGER_LOGGER_SILENT=true/false
## _LOGGER_LOGGER_VERBOSE=true/false
2016-11-14 18:17:30 +00:00
## _LOGGER_ERR_ONLY=true/false
2016-11-14 18:05:29 +00:00
## _LOGGER_PREFIX="date"/"time"/""
2015-11-12 00:37:43 +00:00
2016-11-15 20:26:52 +00:00
## Logger sets {ERROR|WARN}_ALERT variable when called with critical / error / warn loglevel
## When called from subprocesses, variable of main process can't be set. Status needs to be get via $RUN_DIR/$PROGRAM.Logger.{error|warn}.$SCRIPT_PID
2016-11-17 13:02:34 +00:00
#TODO: Rewrite Logger so we can decide what to send to stdout, stderr and logfile
2016-09-05 20:06:57 +00:00
#TODO: Windows checks, check sendmail & mailsend
2015-11-12 00:37:43 +00:00
if ! type " $BASH " > /dev/null; then
echo "Please run this script only with bash shell. Tested on bash >= 3.2"
exit 127
fi
2016-03-19 09:48:46 +00:00
## Correct output of sort command (language agnostic sorting)
export LC_ALL = C
# Standard alert mail body
MAIL_ALERT_MSG = " Execution of $PROGRAM instance $INSTANCE_ID on $( date) has warnings/errors. "
2016-08-06 11:17:56 +00:00
# Environment variables that can be overriden by programs
2016-08-29 11:48:03 +00:00
_DRYRUN = false
2016-11-17 19:00:23 +00:00
_LOGGER_SILENT = false
_LOGGER_VERBOSE = false
_LOGGER_ERR_ONLY = false
2016-08-06 11:17:56 +00:00
_LOGGER_PREFIX = "date"
2016-08-18 21:28:41 +00:00
if [ " $KEEP_LOGGING " = = "" ] ; then
KEEP_LOGGING = 1801
fi
2015-11-12 00:37:43 +00:00
# Initial error status, logging 'WARN', 'ERROR' or 'CRITICAL' will enable alerts flags
2016-08-29 11:48:03 +00:00
ERROR_ALERT = false
WARN_ALERT = false
2015-11-12 00:37:43 +00:00
## allow function call checks #__WITH_PARANOIA_DEBUG
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then #__WITH_PARANOIA_DEBUG
_DEBUG = yes #__WITH_PARANOIA_DEBUG
fi #__WITH_PARANOIA_DEBUG
## allow debugging from command line with _DEBUG=yes
if [ ! " $_DEBUG " = = "yes" ] ; then
_DEBUG = no
2016-08-03 08:02:07 +00:00
SLEEP_TIME = .05 # Tested under linux and FreeBSD bash, #TODO tests on cygwin / msys
2016-11-17 19:00:23 +00:00
_LOGGER_VERBOSE = false
2015-11-12 00:37:43 +00:00
else
2016-11-17 13:02:34 +00:00
if [ " $SLEEP_TIME " = = "" ] ; then # Set SLEEP_TIME as environment variable when runinng with bash -x in order to avoid spamming console
SLEEP_TIME = .05
2016-11-15 11:24:42 +00:00
fi
2015-11-12 00:37:43 +00:00
trap 'TrapError ${LINENO} $?' ERR
2016-11-17 19:00:23 +00:00
_LOGGER_VERBOSE = true
2015-11-12 00:37:43 +00:00
fi
SCRIPT_PID = $$
LOCAL_USER = $( whoami)
LOCAL_HOST = $( hostname)
2016-08-28 09:32:25 +00:00
if [ " $PROGRAM " = = "" ] ; then
PROGRAM = "ofunctions"
fi
2015-11-12 00:37:43 +00:00
## Default log file until config file is loaded
if [ -w /var/log ] ; then
LOG_FILE = " /var/log/ $PROGRAM .log "
2016-04-06 18:13:19 +00:00
elif ( [ " $HOME " != "" ] && [ -w " $HOME " ] ) ; then
LOG_FILE = " $HOME / $PROGRAM .log "
2015-11-12 00:37:43 +00:00
else
LOG_FILE = " ./ $PROGRAM .log "
fi
## Default directory where to store temporary run files
if [ -w /tmp ] ; then
RUN_DIR = /tmp
elif [ -w /var/tmp ] ; then
RUN_DIR = /var/tmp
else
RUN_DIR = .
fi
# Default alert attachment filename
2016-11-10 14:54:59 +00:00
ALERT_LOG_FILE = " $RUN_DIR / $PROGRAM . $SCRIPT_PID .last.log "
2015-11-12 00:37:43 +00:00
# Set error exit code if a piped command fails
set -o pipefail
set -o errtrace
function Dummy {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-08-06 11:17:56 +00:00
sleep $SLEEP_TIME
2015-11-12 00:37:43 +00:00
}
2016-05-26 20:11:00 +00:00
# Sub function of Logger
2015-11-12 00:37:43 +00:00
function _Logger {
2016-11-17 19:00:23 +00:00
local logValue = " ${ 1 } " # Log to file
local stdValue = " ${ 2 } " # Log to screeen
local toStderr = " ${ 3 :- false } " # Log to stderr instead of stdout
echo -e " $logValue " >> " $LOG_FILE "
# Current log file
echo -e " $logValue " >> " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID "
if [ " $stdValue " != "" ] && [ " $_LOGGER_SILENT " != true ] ; then
if [ $toStderr = = true ] ; then
# Force stderr color in subshell
( >& 2 echo -e " $stdValue " )
else
echo -e " $stdValue "
fi
fi
}
# General log function with log levels:
# Environment variables
# _LOGGER_SILENT: Disables any output to stdout & stderr
# _LOGGER_STD_ERR: Disables any output to stdout except for ALWAYS loglevel
# _LOGGER_VERBOSE: Allows VERBOSE loglevel messages to be sent to stdout
# Loglevels
# Except for VERBOSE, all loglevels are ALWAYS sent to log file
# CRITICAL, ERROR, WARN sent to stderr, color depending on level, level also logged
# NOTICE sent to stdout
# VERBOSE sent to stdout if _LOGGER_VERBOSE = true
# ALWAYS is sent to stdout unless _LOGGER_SILENT = true
# DEBUG & PARANOIA_DEBUG are only sent to stdout if _DEBUG=yes
function Logger {
local value = " ${ 1 } " # Sentence to log (in double quotes)
local level = " ${ 2 } " # Log level
if [ " $_LOGGER_PREFIX " = = "time" ] ; then
prefix = " TIME: $SECONDS - "
elif [ " $_LOGGER_PREFIX " = = "date" ] ; then
prefix = " $( date) - "
else
prefix = ""
fi
if [ " $level " = = "CRITICAL" ] ; then
_Logger " $prefix ( $level ): $value " " $prefix \e[41m $value \e[0m " true
ERROR_ALERT = true
# ERROR_ALERT / WARN_ALERT isn't set in main when Logger is called from a subprocess. Need to keep this flag.
echo "1" > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } .error. $SCRIPT_PID "
return
elif [ " $level " = = "ERROR" ] ; then
_Logger " $prefix ( $level ): $value " " $prefix \e[91m $value \e[0m " true
ERROR_ALERT = true
echo "1" > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } .error. $SCRIPT_PID "
return
elif [ " $level " = = "WARN" ] ; then
_Logger " $prefix ( $level ): $value " " $prefix \e[33m $value \e[0m " true
WARN_ALERT = true
echo "1" > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } .warn. $SCRIPT_PID "
return
elif [ " $level " = = "NOTICE" ] ; then
if [ " $_LOGGER_ERR_ONLY " != true ] ; then
_Logger " $prefix $value " " $prefix $value "
fi
return
elif [ " $level " = = "VERBOSE" ] ; then
if [ $_LOGGER_VERBOSE = = true ] ; then
_Logger " $prefix : $value " " $prefix $value "
fi
return
elif [ " $level " = = "ALWAYS" ] ; then
_Logger " $prefix $value " " $prefix $value "
return
elif [ " $level " = = "DEBUG" ] ; then
if [ " $_DEBUG " = = "yes" ] ; then
_Logger " $prefix $value " " $prefix $value "
return
fi
elif [ " $level " = = "PARANOIA_DEBUG" ] ; then #__WITH_PARANOIA_DEBUG
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then #__WITH_PARANOIA_DEBUG
_Logger " $prefix $value " " $prefix $value " #__WITH_PARANOIA_DEBUG
return #__WITH_PARANOIA_DEBUG
fi #__WITH_PARANOIA_DEBUG
else
_Logger " \e[41mLogger function called without proper loglevel [ $level ].\e[0m "
_Logger " Value was: $prefix $value "
fi
}
2016-05-26 20:11:00 +00:00
# QuickLogger subfunction, can be called directly
function _QuickLogger {
local value = " ${ 1 } "
local destination = " ${ 2 } " # Destination: stdout, log, both
2016-08-06 11:17:56 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-05-26 20:11:00 +00:00
if ( [ " $destination " = = "log" ] || [ " $destination " = = "both" ] ) ; then
echo -e " $( date) - $value " >> " $LOG_FILE "
elif ( [ " $destination " = = "stdout" ] || [ " $destination " = = "both" ] ) ; then
echo -e " $value "
fi
}
# Generic quick logging function
function QuickLogger {
local value = " ${ 1 } "
2016-08-06 11:17:56 +00:00
__CheckArguments 1 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-11-17 19:00:23 +00:00
if [ $_LOGGER_SILENT = = true ] ; then
2016-05-26 20:11:00 +00:00
_QuickLogger " $value " "log"
else
_QuickLogger " $value " "stdout"
fi
}
2015-11-12 00:37:43 +00:00
# Portable child (and grandchild) kill function tester under Linux, BSD and MacOS X
function KillChilds {
2016-08-18 21:28:41 +00:00
local pid = " ${ 1 } " # Parent pid to kill childs
local self = " ${ 2 :- false } " # Should parent be killed too ?
2015-11-12 00:37:43 +00:00
2016-08-03 08:02:07 +00:00
2016-08-03 21:58:24 +00:00
if children = " $( pgrep -P " $pid " ) " ; then
for child in $children ; do
Logger " Launching KillChilds \" $child \" true " "DEBUG" #__WITH_PARANOIA_DEBUG
KillChilds " $child " true
done
fi
2016-08-03 08:02:07 +00:00
# Try to kill nicely, if not, wait 15 seconds to let Trap actions happen before killing
2016-08-03 21:58:24 +00:00
if ( [ " $self " = = true ] && kill -0 $pid > /dev/null 2>& 1) ; then
Logger " Sending SIGTERM to process [ $pid ]. " "DEBUG"
2016-08-22 05:55:03 +00:00
kill -s TERM " $pid "
2016-08-03 21:58:24 +00:00
if [ $? != 0 ] ; then
sleep 15
Logger " Sending SIGTERM to process [ $pid ] failed. " "DEBUG"
kill -9 " $pid "
2016-04-12 08:16:21 +00:00
if [ $? != 0 ] ; then
2016-08-03 21:58:24 +00:00
Logger " Sending SIGKILL to process [ $pid ] failed. " "DEBUG"
return 1
2016-04-12 08:16:21 +00:00
fi
2016-08-03 08:02:07 +00:00
else
2016-08-03 21:58:24 +00:00
return 0
2016-03-31 20:32:03 +00:00
fi
2016-08-03 21:58:24 +00:00
else
return 0
fi
}
function KillAllChilds {
local pids = " ${ 1 } " # List of parent pids to kill separated by semi-colon
2016-08-18 21:28:41 +00:00
local self = " ${ 2 :- false } " # Should parent be killed too ?
2016-08-03 21:58:24 +00:00
2016-08-06 11:17:56 +00:00
__CheckArguments 1 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-08-03 21:58:24 +00:00
local errorcount = 0
IFS = ';' read -a pidsArray <<< " $pids "
for pid in " ${ pidsArray [@] } " ; do
2016-08-18 21:28:41 +00:00
KillChilds $pid $self
2016-08-03 21:58:24 +00:00
if [ $? != 0 ] ; then
errorcount = $(( errorcount+1))
fi
2016-08-03 08:02:07 +00:00
done
return $errorcount
2015-11-12 00:37:43 +00:00
}
2016-05-25 17:57:04 +00:00
# osync/obackup/pmocr script specific mail alert function, use SendEmail function for generic mail sending
2015-11-12 00:37:43 +00:00
function SendAlert {
2016-08-28 09:32:25 +00:00
local runAlert = " ${ 1 :- false } " # Specifies if current message is sent while running or at the end of a run
__CheckArguments 0-1 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-02-18 19:54:07 +00:00
2016-11-17 20:02:45 +00:00
local attachment
local attachmentFile
local subject
local body
2015-11-12 00:37:43 +00:00
2016-03-08 22:54:25 +00:00
if [ " $DESTINATION_MAILS " = = "" ] ; then
return 0
fi
2015-11-12 00:37:43 +00:00
if [ " $_DEBUG " = = "yes" ] ; then
2016-05-25 17:57:04 +00:00
Logger "Debug mode, no warning mail will be sent." "NOTICE"
2015-11-12 00:37:43 +00:00
return 0
fi
# <OSYNC SPECIFIC>
2016-10-23 16:23:44 +00:00
if [ " $_QUICK_SYNC " = = "2" ] ; then
2015-11-12 00:37:43 +00:00
Logger "Current task is a quicksync task. Will not send any alert." "NOTICE"
return 0
fi
# </OSYNC SPECIFIC>
eval " cat \" $LOG_FILE \" $COMPRESSION_PROGRAM > $ALERT_LOG_FILE "
2016-02-16 21:15:44 +00:00
if [ $? != 0 ] ; then
Logger " Cannot create [ $ALERT_LOG_FILE ] " "WARN"
2016-11-14 18:17:30 +00:00
attachment = false
2016-02-16 21:15:44 +00:00
else
2016-11-14 18:05:29 +00:00
attachment = true
2016-02-16 21:15:44 +00:00
fi
2016-11-17 19:00:23 +00:00
if [ -e " $RUN_DIR / $PROGRAM ._Logger. $SCRIPT_PID " ] ; then
body = " $MAIL_ALERT_MSG " $'\n\n' " $( cat $RUN_DIR /$PROGRAM ._Logger.$SCRIPT_PID ) "
fi
2016-08-28 09:32:25 +00:00
2016-08-29 11:48:03 +00:00
if [ $ERROR_ALERT = = true ] ; then
2015-11-12 00:37:43 +00:00
subject = " Error alert for $INSTANCE_ID "
2016-08-29 11:48:03 +00:00
elif [ $WARN_ALERT = = true ] ; then
2015-11-12 00:37:43 +00:00
subject = " Warning alert for $INSTANCE_ID "
else
subject = " Alert for $INSTANCE_ID "
fi
2016-08-28 09:32:25 +00:00
if [ $runAlert = = true ] ; then
subject = " Currently runing - $subject "
else
subject = " Fnished run - $subject "
fi
2016-11-14 18:05:29 +00:00
if [ " $attachment " = = true ] ; then
2016-11-11 23:30:25 +00:00
attachmentFile = " $ALERT_LOG_FILE "
2015-11-12 00:37:43 +00:00
fi
2016-11-11 23:30:25 +00:00
SendEmail " $subject " " $body " " $DESTINATION_MAILS " " $attachmentFile " " $SENDER_MAIL " " $SMTP_SERVER " " $SMTP_PORT " " $ENCRYPTION " "SMTP_USER" " $SMTP_PASSWORD "
2015-11-12 00:37:43 +00:00
# Delete tmp log file
2016-11-14 18:05:29 +00:00
if [ " $attachment " = = true ] ; then
2016-11-11 23:30:25 +00:00
if [ -f " $ALERT_LOG_FILE " ] ; then
rm -f " $ALERT_LOG_FILE "
fi
2015-11-12 00:37:43 +00:00
fi
}
2016-05-25 17:57:04 +00:00
# Generic email sending function.
# Usage (linux / BSD), attachment is optional, can be "/path/to/my.file" or ""
# SendEmail "subject" "Body text" "receiver@example.com receiver2@otherdomain.com" "/path/to/attachment.file"
# Usage (Windows, make sure you have mailsend.exe in executable path, see http://github.com/muquit/mailsend)
# attachment is optional but must be in windows format like "c:\\some\path\\my.file", or ""
2016-10-23 16:23:44 +00:00
# smtp_server.domain.tld is mandatory, as is smtpPort (should be 25, 465 or 587)
2016-05-25 17:57:04 +00:00
# encryption can be set to tls, ssl or none
2016-10-23 16:23:44 +00:00
# smtpUser and smtpPassword are optional
2016-10-23 18:25:46 +00:00
# SendEmail "subject" "Body text" "receiver@example.com receiver2@otherdomain.com" "/path/to/attachment.file" "senderMail@example.com" "smtpServer.domain.tld" "smtpPort" "encryption" "smtpUser" "smtpPassword"
2016-04-14 16:01:56 +00:00
function SendEmail {
local subject = " ${ 1 } "
local message = " ${ 2 } "
2016-10-23 16:23:44 +00:00
local destinationMails = " ${ 3 } "
2016-05-25 17:57:04 +00:00
local attachment = " ${ 4 } "
2016-10-23 18:25:46 +00:00
local senderMail = " ${ 5 } "
2016-10-23 16:23:44 +00:00
local smtpServer = " ${ 6 } "
local smtpPort = " ${ 7 } "
2016-07-19 08:52:43 +00:00
local encryption = " ${ 8 } "
2016-10-23 16:23:44 +00:00
local smtpUser = " ${ 9 } "
local smtpPassword = " ${ 10 } "
2016-05-25 17:57:04 +00:00
# CheckArguments will report a warning that can be ignored if used in Windows with paranoia debug enabled
2016-04-14 16:01:56 +00:00
__CheckArguments 4 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
local mail_no_attachment =
local attachment_command =
2016-05-25 17:57:04 +00:00
local encryption_string =
local auth_string =
2016-04-14 16:01:56 +00:00
if [ ! -f " $attachment " ] ; then
2016-11-09 16:36:18 +00:00
attachment_command = " -a $attachment "
2016-04-14 16:01:56 +00:00
mail_no_attachment = 1
else
mail_no_attachment = 0
fi
2016-11-19 11:37:33 +00:00
if [ " $LOCAL_OS " = = "Busybox" ] || [ " $LOCAL_OS " = = "Android" ] ; then
2016-10-23 16:23:44 +00:00
if type sendmail > /dev/null 2>& 1; then
2016-10-23 18:25:46 +00:00
if [ " $ENCRYPTION " = = "tls" ] ; then
echo -e " Subject: $subject \r\n $message " | $( type -p sendmail) -f " $SenderMail " -H " exec openssl s_client -quiet -tls1_2 -starttls smtp -connect $smtpServer : $smtpPort " -au" $smtpUser " -ap" $smtpPassword " " $destinationMails "
elif [ " $ENCRYPTION " = = "ssl" ] ; then
echo -e " Subject: $subject \r\n $message " | $( type -p sendmail) -f " $SenderMail " -H " exec openssl s_client -quiet -connect $smtpServer : $smtpPort " -au" $smtpUser " -ap" $smtpPassword " " $destinationMails "
else
echo -e " Subject: $subject \r\n $message " | $( type -p sendmail) -f " $SenderMail " -S " $smtpServer : $SmtpPort " -au" $smtpUser " -ap" $smtpPassword " " $destinationMails "
fi
2016-10-23 16:23:44 +00:00
if [ $? != 0 ] ; then
Logger " Cannot send alert mail via $( type -p sendmail) !!! " "WARN"
# Don't bother try other mail systems with busybox
return 1
else
return 0
fi
else
Logger "Sendmail not present. Won't send any mail" "WARN"
return 1
fi
fi
2016-04-14 16:01:56 +00:00
if type mutt > /dev/null 2>& 1 ; then
2016-10-23 16:23:44 +00:00
echo " $message " | $( type -p mutt) -x -s " $subject " " $destinationMails " $attachment_command
2016-04-14 16:01:56 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p mutt) !!! " "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using mutt." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
if type mail > /dev/null 2>& 1 ; then
2016-11-21 13:04:05 +00:00
# We need to detect which version of mail is installed
if ! $( type -p mail) -V > /dev/null 2>& 1; then
# This may be MacOS mail program
attachment_command = ""
elif [ " $mail_no_attachment " -eq 0 ] && $( type -p mail) -V | grep "GNU" > /dev/null; then
2016-04-14 16:01:56 +00:00
attachment_command = " -A $attachment "
elif [ " $mail_no_attachment " -eq 0 ] && $( type -p mail) -V > /dev/null; then
attachment_command = " -a $attachment "
else
attachment_command = ""
fi
2016-11-21 13:04:05 +00:00
2016-10-23 16:23:44 +00:00
echo " $message " | $( type -p mail) $attachment_command -s " $subject " " $destinationMails "
2016-04-14 16:01:56 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p mail) with attachments !!! " "WARN"
2016-10-23 16:23:44 +00:00
echo " $message " | $( type -p mail) -s " $subject " " $destinationMails "
2016-04-14 16:01:56 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p mail) without attachments !!! " "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using mail command without attachment." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using mail command." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
if type sendmail > /dev/null 2>& 1 ; then
2016-10-23 16:23:44 +00:00
echo -e " Subject: $subject \r\n $message " | $( type -p sendmail) " $destinationMails "
2016-04-14 16:01:56 +00:00
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger " Cannot send mail via $( type -p sendmail) !!! " "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using sendmail command without attachment." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
2016-05-25 17:57:04 +00:00
# Windows specific
2016-08-08 16:06:31 +00:00
if type "mailsend.exe" > /dev/null 2>& 1 ; then
2016-10-23 18:25:46 +00:00
if [ " $senderMail " = = "" ] ; then
2016-05-25 17:57:04 +00:00
Logger "Missing sender email." "ERROR"
return 1
fi
2016-10-23 16:23:44 +00:00
if [ " $smtpServer " = = "" ] ; then
2016-05-25 17:57:04 +00:00
Logger "Missing smtp port." "ERROR"
return 1
fi
2016-10-23 16:23:44 +00:00
if [ " $smtpPort " = = "" ] ; then
2016-05-25 17:57:04 +00:00
Logger "Missing smtp port, assuming 25." "WARN"
2016-10-23 16:23:44 +00:00
smtpPort = 25
2016-05-25 17:57:04 +00:00
fi
if [ " $encryption " != "tls" ] && [ " $encryption " != "ssl" ] && [ " $encryption " != "none" ] ; then
Logger "Bogus smtp encryption, assuming none." "WARN"
encryption_string =
elif [ " $encryption " = = "tls" ] ; then
encryption_string = -starttls
elif [ " $encryption " = = "ssl" ] :; then
encryption_string = -ssl
fi
2016-10-23 16:23:44 +00:00
if [ " $smtpUser " != "" ] && [ " $smtpPassword " != "" ] ; then
auth_string = " -auth -user \" $smtpUser \" -pass \" $smtpPassword \" "
2016-05-25 17:57:04 +00:00
fi
2016-10-23 18:25:46 +00:00
$( type mailsend.exe) -f " $senderMail " -t " $destinationMails " -sub " $subject " -M " $message " -attach " $attachment " -smtp " $smtpServer " -port " $smtpPort " $encryption_string $auth_string
2016-08-08 16:06:31 +00:00
if [ $? != 0 ] ; then
Logger " Cannot send mail via $( type mailsend.exe) !!! " "WARN"
else
Logger "Sent mail using mailsend.exe command with attachment." "NOTICE"
return 0
fi
fi
2016-05-25 17:57:04 +00:00
2016-04-14 16:01:56 +00:00
# pfSense specific
if [ -f /usr/local/bin/mail.php ] ; then
echo " $message " | /usr/local/bin/mail.php -s= " $subject "
if [ $? != 0 ] ; then
2016-05-25 17:57:04 +00:00
Logger "Cannot send mail via /usr/local/bin/mail.php (pfsense) !!!" "WARN"
2016-04-14 16:01:56 +00:00
else
2016-05-25 17:57:04 +00:00
Logger "Sent mail using pfSense mail.php." "NOTICE"
2016-04-14 16:01:56 +00:00
return 0
fi
fi
2016-08-02 12:26:04 +00:00
# If function has not returned 0 yet, assume it is critical that no alert can be sent
2016-05-25 17:57:04 +00:00
Logger "Cannot send mail (neither mutt, mail, sendmail, sendemail, mailsend (windows) or pfSense mail.php could be used)." "ERROR" # Is not marked critical because execution must continue
2016-04-14 16:01:56 +00:00
}
2016-03-08 22:54:25 +00:00
function TrapError {
local job = " $0 "
local line = " $1 "
local code = " ${ 2 :- 1 } "
2016-10-19 10:28:30 +00:00
2016-11-17 19:00:23 +00:00
if [ $_LOGGER_SILENT = = false ] ; then
2016-11-14 21:04:54 +00:00
echo -e " \e[45m/!\ ERROR in ${ job } : Near line ${ line } , exit code ${ code } \e[0m "
2016-03-08 22:54:25 +00:00
fi
}
2016-03-19 09:48:46 +00:00
function LoadConfigFile {
2016-09-06 17:08:53 +00:00
local configFile = " ${ 1 } "
2016-10-19 10:28:30 +00:00
2016-03-19 09:48:46 +00:00
__CheckArguments 1 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-09-06 17:08:53 +00:00
if [ ! -f " $configFile " ] ; then
Logger " Cannot load configuration file [ $configFile ]. Cannot start. " "CRITICAL"
2016-03-19 09:48:46 +00:00
exit 1
2016-09-06 17:08:53 +00:00
elif [ [ " $configFile " != *".conf" ] ] ; then
Logger " Wrong configuration file supplied [ $configFile ]. Cannot start. " "CRITICAL"
2016-03-19 09:48:46 +00:00
exit 1
else
2016-09-06 17:08:53 +00:00
# Remove everything that is not a variable assignation
grep '^[^ ]*=[^;&]*' " $configFile " > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID "
2016-03-19 09:48:46 +00:00
source " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID "
fi
2016-09-06 17:08:53 +00:00
CONFIG_FILE = " $configFile "
2016-03-19 09:48:46 +00:00
}
2016-03-08 22:54:25 +00:00
function Spinner {
2016-11-17 19:00:23 +00:00
if [ $_LOGGER_SILENT = = true ] || [ " $_LOGGER_ERR_ONLY " = = true ] ; then
2016-03-08 22:54:25 +00:00
return 0
fi
2016-11-20 21:18:36 +00:00
case $_OFUNCTIONS_SPINNER_TOGGLE
2016-03-08 22:54:25 +00:00
in
1)
echo -n " \ "
echo -ne "\r"
2016-11-20 21:18:36 +00:00
_OFUNCTIONS_SPINNER_TOGGLE = 2
2016-03-08 22:54:25 +00:00
; ;
2)
echo -n " | "
echo -ne "\r"
2016-11-20 21:18:36 +00:00
_OFUNCTIONS_SPINNER_TOGGLE = 3
2016-03-08 22:54:25 +00:00
; ;
3)
echo -n " / "
echo -ne "\r"
2016-11-20 21:18:36 +00:00
_OFUNCTIONS_SPINNER_TOGGLE = 4
2016-03-08 22:54:25 +00:00
; ;
*)
echo -n " - "
echo -ne "\r"
2016-11-20 21:18:36 +00:00
_OFUNCTIONS_SPINNER_TOGGLE = 1
2016-03-08 22:54:25 +00:00
; ;
esac
}
2016-08-08 16:06:31 +00:00
# Array to string converter, see http://stackoverflow.com/questions/1527049/bash-join-elements-of-an-array
# usage: joinString separaratorChar Array
function joinString {
local IFS = " $1 " ; shift; echo " $* " ;
}
2016-08-09 20:14:17 +00:00
# Time control function for background processes, suitable for multiple synchronous processes
# Fills a global variable called WAIT_FOR_TASK_COMPLETION that contains list of failed pids in format pid1:result1;pid2:result2
# Warning: Don't imbricate this function into another run if you plan to use the global variable output
2016-08-28 09:32:25 +00:00
2016-11-22 16:19:30 +00:00
# Standard wait $! emulation would be WaitForTaskCompletion $! 0 0 ${FUNCNAME[0]} true 0 true false
#TODO: function WaitForTask $pid $softTime $hardTime $sleepTime $keepLogging $counting $spinner $noErrror $callerName
2016-08-06 11:17:56 +00:00
function WaitForTaskCompletion {
local pids = " ${ 1 } " # pids to wait for, separated by semi-colon
2016-10-19 10:28:30 +00:00
local softMaxTime = " ${ 2 } " # If program with pid $pid takes longer than $softMaxTime seconds, will log a warning, unless $softMaxTime equals 0.
local hardMaxTime = " ${ 3 } " # If program with pid $pid takes longer than $hardMaxTime seconds, will stop execution, unless $hardMaxTime equals 0.
local callerName = " ${ 4 } " # Who called this function
2016-08-18 21:28:41 +00:00
local counting = " ${ 5 :- true } " # Count time since function has been launched if true, since script has been launched if false
2016-10-19 10:28:30 +00:00
local keepLogging = " ${ 6 :- 0 } " # Log a standby message every X seconds. Set to zero to disable logging
2016-11-21 18:18:22 +00:00
local noError = " ${ 7 :- false } " # When set to true, reaching soft or hard max time does not trigger an error
2016-11-22 16:19:30 +00:00
local spinner = " ${ 8 :- true } " # Do we show spinner ?
local sleepTime = " ${ 9 :- 0 } " # Override SLEEP_TIME
2016-08-06 11:17:56 +00:00
2016-10-19 10:28:30 +00:00
Logger " ${ FUNCNAME [0] } called by [ $callerName ]. " "PARANOIA_DEBUG" #__WITH_PARANOIA_DEBUG
2016-11-22 16:19:30 +00:00
__CheckArguments 6-8 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-08-06 11:17:56 +00:00
2016-08-30 09:49:21 +00:00
local soft_alert = false # Does a soft alert need to be triggered, if yes, send an alert once
2016-08-06 11:17:56 +00:00
local log_ttime = 0 # local time instance for comparaison
local seconds_begin = $SECONDS # Seconds since the beginning of the script
local exec_time = 0 # Seconds since the beginning of this function
local retval = 0 # return value of monitored pid process
local errorcount = 0 # Number of pids that finished with errors
2016-08-28 15:54:20 +00:00
local pid # Current pid working on
2016-08-06 11:17:56 +00:00
local pidCount # number of given pids
2016-08-18 21:28:41 +00:00
local pidState # State of the process
2016-08-06 11:17:56 +00:00
2016-08-28 15:54:20 +00:00
local pidsArray # Array of currently running pids
local newPidsArray # New array of currently running pids
2016-08-30 09:49:21 +00:00
local hasPids = false # Are any valable pids given to function ? #__WITH_PARANOIA_DEBUG
2016-08-06 11:17:56 +00:00
IFS = ';' read -a pidsArray <<< " $pids "
pidCount = ${# pidsArray [@] }
2016-08-09 20:14:17 +00:00
WAIT_FOR_TASK_COMPLETION = ""
2016-11-22 16:19:30 +00:00
# Default value when not overriden
if [ $sleepTime -eq 0 ] ; then
sleepTime = $SLEEP_TIME
fi
2016-08-06 11:17:56 +00:00
while [ ${# pidsArray [@] } -gt 0 ] ; do
newPidsArray = ( )
2016-11-22 16:19:30 +00:00
if [ $spinner = = true ] ; then
Spinner
fi
2016-08-07 21:54:46 +00:00
if [ $counting = = true ] ; then
exec_time = $(( $SECONDS - $seconds_begin ))
else
exec_time = $SECONDS
fi
2016-10-19 10:28:30 +00:00
if [ $keepLogging -ne 0 ] ; then
if [ $(( ( $exec_time + 1 ) % $keepLogging )) -eq 0 ] ; then
2016-08-18 21:28:41 +00:00
if [ $log_ttime -ne $exec_time ] ; then # Fix when sleep time lower than 1s
log_ttime = $exec_time
Logger " Current tasks still running with pids [ $( joinString , ${ pidsArray [@] } ) ]. " "NOTICE"
fi
2016-08-06 11:17:56 +00:00
fi
fi
2016-10-19 10:28:30 +00:00
if [ $exec_time -gt $softMaxTime ] ; then
2016-11-21 18:18:22 +00:00
if [ $soft_alert = = true ] && [ $softMaxTime -ne 0 ] && [ $noError != true ] ; then
2016-10-19 10:28:30 +00:00
Logger " Max soft execution time exceeded for task [ $callerName ] with pids [ $( joinString , ${ pidsArray [@] } ) ]. " "WARN"
2016-08-30 09:49:21 +00:00
soft_alert = true
2016-08-28 09:32:25 +00:00
SendAlert true
2016-08-06 11:17:56 +00:00
fi
2016-10-19 10:28:30 +00:00
if [ $exec_time -gt $hardMaxTime ] && [ $hardMaxTime -ne 0 ] ; then
2016-11-21 18:18:22 +00:00
if [ $noError != true ] ; then
Logger " Max hard execution time exceeded for task [ $callerName ] with pids [ $( joinString , ${ pidsArray [@] } ) ]. Stopping task execution. " "ERROR"
fi
2016-08-18 21:28:41 +00:00
for pid in " ${ pidsArray [@] } " ; do
KillChilds $pid true
if [ $? = = 0 ] ; then
Logger " Task with pid [ $pid ] stopped successfully. " "NOTICE"
else
Logger " Could not stop task with pid [ $pid ]. " "ERROR"
fi
done
2016-11-21 18:18:22 +00:00
if [ $noError != true ] ; then
SendAlert true
fi
2016-08-06 11:17:56 +00:00
fi
fi
2016-08-22 06:09:48 +00:00
for pid in " ${ pidsArray [@] } " ; do
2016-09-05 20:06:57 +00:00
if [ $( IsInteger $pid ) -eq 1 ] ; then
2016-08-30 09:37:25 +00:00
if kill -0 $pid > /dev/null 2>& 1; then
# Handle uninterruptible sleep state or zombies by ommiting them from running process array (How to kill that is already dead ? :)
2016-10-22 12:14:52 +00:00
pidState = " $( eval $PROCESS_STATE_CMD ) "
2016-08-30 09:37:25 +00:00
if [ " $pidState " != "D" ] && [ " $pidState " != "Z" ] ; then
newPidsArray += ( $pid )
fi
else
# pid is dead, get it's exit code from wait command
wait $pid
retval = $?
if [ $retval -ne 0 ] ; then
errorcount = $(( errorcount+1))
2016-10-19 10:28:30 +00:00
Logger " ${ FUNCNAME [0] } called by [ $callerName ] finished monitoring [ $pid ] with exitcode [ $retval ]. " "DEBUG"
2016-08-30 09:37:25 +00:00
if [ " $WAIT_FOR_TASK_COMPLETION " = = "" ] ; then
WAIT_FOR_TASK_COMPLETION = " $pid : $retval "
else
WAIT_FOR_TASK_COMPLETION = " ; $pid : $retval "
fi
2016-08-22 06:09:48 +00:00
fi
fi
2016-08-30 09:49:21 +00:00
hasPids = true ##__WITH_PARANOIA_DEBUG
2016-08-22 06:09:48 +00:00
fi
done
2016-08-30 09:49:21 +00:00
if [ $hasPids = = false ] ; then ##__WITH_PARANOIA_DEBUG
Logger "No valable pids given." "ERROR" ##__WITH_PARANOIA_DEBUG
fi ##__WITH_PARANOIA_DEBUG
2016-08-06 11:17:56 +00:00
pidsArray = ( " ${ newPidsArray [@] } " )
2016-08-28 09:32:25 +00:00
# Trivial wait time for bash to not eat up all CPU
2016-11-22 16:19:30 +00:00
sleep $sleepTime
2016-08-06 11:17:56 +00:00
done
2016-10-19 10:28:30 +00:00
Logger " ${ FUNCNAME [0] } ended for [ $callerName ] using [ $pidCount ] subprocesses with [ $errorcount ] errors. " "PARANOIA_DEBUG" #__WITH_PARANOIA_DEBUG
2016-08-18 21:28:41 +00:00
# Return exit code if only one process was monitored, else return number of errors
if [ $pidCount -eq 1 ] && [ $errorcount -eq 0 ] ; then
return $errorcount
2016-08-06 11:17:56 +00:00
else
return $errorcount
fi
}
2016-08-28 09:32:25 +00:00
# Take a list of commands to run, runs them sequentially with numberOfProcesses commands simultaneously runs
# Returns the number of non zero exit codes from commands
2016-09-06 17:27:45 +00:00
# Use cmd1;cmd2;cmd3 syntax for small sets, use file for large command sets
2016-08-28 09:32:25 +00:00
function ParallelExec {
local numberOfProcesses = " ${ 1 } " # Number of simultaneous commands to run
2016-09-06 17:08:53 +00:00
local commandsArg = " ${ 2 } " # Semi-colon separated list of commands, or file containing one command per line
2016-09-08 20:49:51 +00:00
local readFromFile = " ${ 3 :- false } " # Is commandsArg a file or a string ?
2016-10-19 10:28:30 +00:00
local softMaxTime = " ${ 4 :- 0 } "
local hardMaxTime = " ${ 5 :- 0 } "
local callerName = " ${ 6 } " # Who called this function
local counting = " ${ 7 :- true } " # Count time since function has been launched if true, since script has been launched if false
local keepLogging = " ${ 8 :- 0 } " # Log a standby message every X seconds. Set to zero to disable logging
2016-09-08 20:49:51 +00:00
2016-10-19 10:28:30 +00:00
__CheckArguments 8 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-08-28 09:32:25 +00:00
2016-09-06 17:08:53 +00:00
local commandCount
local command
2016-08-28 09:32:25 +00:00
local pid
local counter = 0
local commandsArray
local pidsArray
local newPidsArray
local retval
2016-09-05 20:06:57 +00:00
local errorCount = 0
2016-08-28 09:32:25 +00:00
local pidState
local commandsArrayPid
2016-08-30 09:49:21 +00:00
local hasPids = false # Are any valable pids given to function ? #__WITH_PARANOIA_DEBUG
2016-09-08 20:49:51 +00:00
if [ $readFromFile = = true ] ; then
if [ -f " $commandsArg " ] ; then
commandCount = $( wc -l < " $commandsArg " )
else
commandCount = 0
fi
2016-09-06 17:08:53 +00:00
else
IFS = ';' read -r -a commandsArray <<< " $commandsArg "
commandCount = ${# commandsArray [@] }
fi
2016-08-28 09:32:25 +00:00
2016-09-06 17:08:53 +00:00
Logger " Runnning $commandCount commands in $numberOfProcesses simultaneous processes. " "DEBUG"
2016-08-28 09:32:25 +00:00
2016-09-06 17:08:53 +00:00
while [ $counter -lt " $commandCount " ] || [ ${# pidsArray [@] } -gt 0 ] ; do
2016-08-28 09:32:25 +00:00
2016-09-06 17:08:53 +00:00
while [ $counter -lt " $commandCount " ] && [ ${# pidsArray [@] } -lt $numberOfProcesses ] ; do
if [ $readFromFile = = true ] ; then
2016-09-08 20:49:51 +00:00
#TODO: Checked on FreeBSD 10, also check on Win
2016-09-06 17:08:53 +00:00
command = $( awk 'NR == num_line {print; exit}' num_line = $(( counter+1)) " $commandsArg " )
else
command = " ${ commandsArray [ $counter ] } "
fi
Logger " Running command [ $command ]. " "DEBUG"
2016-10-19 10:28:30 +00:00
eval " $command " > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " 2>& 1 &
2016-08-28 09:32:25 +00:00
pid = $!
pidsArray += ( $pid )
2016-09-06 17:08:53 +00:00
commandsArrayPid[ $pid ] = " $command "
2016-08-28 09:32:25 +00:00
counter = $(( counter+1))
done
newPidsArray = ( )
for pid in " ${ pidsArray [@] } " ; do
2016-09-05 20:06:57 +00:00
if [ $( IsInteger $pid ) -eq 1 ] ; then
2016-08-30 09:37:25 +00:00
# Handle uninterruptible sleep state or zombies by ommiting them from running process array (How to kill that is already dead ? :)
if kill -0 $pid > /dev/null 2>& 1; then
2016-10-22 12:14:52 +00:00
#pidState=$(ps -p$pid -o state= 2 > /dev/null)
pidState = " $( eval $PROCESS_STATE_CMD ) "
2016-08-30 09:37:25 +00:00
if [ " $pidState " != "D" ] && [ " $pidState " != "Z" ] ; then
newPidsArray += ( $pid )
fi
else
# pid is dead, get it's exit code from wait command
wait $pid
retval = $?
if [ $retval -ne 0 ] ; then
Logger " Command [ ${ commandsArrayPid [ $pid ] } ] failed with exit code [ $retval ]. " "ERROR"
2016-09-05 20:06:57 +00:00
errorCount = $(( errorCount+1))
2016-08-30 09:37:25 +00:00
fi
2016-08-28 09:32:25 +00:00
fi
2016-08-30 09:49:21 +00:00
hasPids = true ##__WITH_PARANOIA_DEBUG
2016-08-28 09:32:25 +00:00
fi
done
2016-08-30 09:49:21 +00:00
if [ $hasPids = = false ] ; then ##__WITH_PARANOIA_DEBUG
Logger "No valable pids given." "ERROR" ##__WITH_PARANOIA_DEBUG
fi ##__WITH_PARANOIA_DEBUG
2016-08-28 09:32:25 +00:00
pidsArray = ( " ${ newPidsArray [@] } " )
# Trivial wait time for bash to not eat up all CPU
sleep $SLEEP_TIME
done
2016-09-05 20:06:57 +00:00
return $errorCount
2016-08-28 09:32:25 +00:00
}
2016-08-07 21:54:46 +00:00
function CleanUp {
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-08-06 11:17:56 +00:00
2016-08-07 21:54:46 +00:00
if [ " $_DEBUG " != "yes" ] ; then
rm -f " $RUN_DIR / $PROGRAM . " *" . $SCRIPT_PID "
# Fix for sed -i requiring backup extension for BSD & Mac (see all sed -i statements)
rm -f " $RUN_DIR / $PROGRAM . " *" . $SCRIPT_PID .tmp "
fi
2016-08-06 11:17:56 +00:00
}
2016-04-14 16:01:56 +00:00
# obsolete, use StripQuotes
2016-03-08 22:54:25 +00:00
function SedStripQuotes {
2016-08-08 16:06:31 +00:00
echo $( echo $1 | sed "s/^\([\"']\)\(.*\)\1\$/\2/g" )
2016-03-08 22:54:25 +00:00
}
2016-04-14 16:01:56 +00:00
# Usage: var=$(StripSingleQuotes "$var")
2016-03-08 22:54:25 +00:00
function StripSingleQuotes {
local string = " ${ 1 } "
2016-10-19 10:28:30 +00:00
2016-03-08 22:54:25 +00:00
string = " ${ string /# \' / } " # Remove singlequote if it begins string
string = " ${ string /% \' / } " # Remove singlequote if it ends string
echo " $string "
}
2016-04-14 16:01:56 +00:00
# Usage: var=$(StripDoubleQuotes "$var")
2016-03-08 22:54:25 +00:00
function StripDoubleQuotes {
local string = " ${ 1 } "
2016-10-19 10:28:30 +00:00
2016-03-08 22:54:25 +00:00
string = " ${ string /# \" / } "
string = " ${ string /% \" / } "
echo " $string "
}
function StripQuotes {
local string = " ${ 1 } "
2016-10-19 10:28:30 +00:00
2016-03-08 22:54:25 +00:00
echo " $( StripSingleQuotes $( StripDoubleQuotes $string ) ) "
}
2016-09-05 20:06:57 +00:00
# Usage var=$(EscapeSpaces "$var") or var="$(EscapeSpaces "$var")"
2016-03-08 22:54:25 +00:00
function EscapeSpaces {
local string = " ${ 1 } " # String on which spaces will be escaped
2016-10-19 10:28:30 +00:00
2016-09-05 20:06:57 +00:00
echo " ${ string // / \\ } "
2016-03-08 22:54:25 +00:00
}
2016-09-05 20:06:57 +00:00
function IsNumericExpand {
2016-08-18 21:28:41 +00:00
eval " local value=\" ${ 1 } \" " # Needed eval so variable variables can be processed
2016-03-08 22:54:25 +00:00
local re = " ^-?[0-9]+([.][0-9]+)? $"
2016-10-19 10:28:30 +00:00
2016-11-13 14:49:40 +00:00
if [ [ $value = ~ ^-?[ 0-9] +( [ .] [ 0-9] +) ?$ ] ] ; then
echo 1
2016-03-08 22:54:25 +00:00
else
2016-11-13 14:49:40 +00:00
echo 0
2016-03-08 22:54:25 +00:00
fi
}
2016-10-21 13:29:49 +00:00
# Usage [ $(IsNumeric $var) -eq 1 ]
2016-09-05 20:06:57 +00:00
function IsNumeric {
local value = " ${ 1 } "
if [ [ $value = ~ ^[ 0-9] +( [ .] [ 0-9] +) ?$ ] ] ; then
2016-11-13 14:49:40 +00:00
echo 1
2016-09-05 20:06:57 +00:00
else
2016-11-13 14:49:40 +00:00
echo 0
2016-09-05 20:06:57 +00:00
fi
}
function IsInteger {
local value = " ${ 1 } "
if [ [ $value = ~ ^[ 0-9] +$ ] ] ; then
2016-11-13 14:49:40 +00:00
echo 1
2016-09-05 20:06:57 +00:00
else
2016-11-13 14:49:40 +00:00
echo 0
2016-09-05 20:06:57 +00:00
fi
}
2016-10-23 08:35:38 +00:00
# Converts human readable sizes into integer kilobyte sizes
2016-10-23 11:27:35 +00:00
# Usage numericSize="$(HumanToNumeric $humanSize)"
2016-10-23 08:35:38 +00:00
function HumanToNumeric {
2016-10-23 11:27:35 +00:00
local value = " ${ 1 } "
2016-10-23 08:35:38 +00:00
local notation
local suffix
local suffixPresent
local multiplier
notation = ( K M G T P E)
for suffix in " ${ notation [@] } " ; do
multiplier = $(( multiplier+1))
2016-10-23 11:27:35 +00:00
if [ [ " $value " = = *" $suffix " * ] ] ; then
2016-10-23 08:35:38 +00:00
suffixPresent = $suffix
break;
fi
done
if [ " $suffixPresent " != "" ] ; then
2016-10-23 11:27:35 +00:00
value = ${ value % $suffix * }
value = ${ value %.* }
2016-10-23 08:35:38 +00:00
# /1024 since we convert to kilobytes instead of bytes
2016-10-23 11:27:35 +00:00
value = $(( value*( 1024 * * multiplier/1024)) )
2016-10-23 08:35:38 +00:00
else
2016-10-23 11:27:35 +00:00
value = ${ value %.* }
2016-10-23 08:35:38 +00:00
fi
2016-10-23 11:27:35 +00:00
echo $value
2016-10-23 08:35:38 +00:00
}
2016-05-26 20:11:00 +00:00
## from https://gist.github.com/cdown/1163649
function urlEncode {
local length = " ${# 1 } "
local LANG = C
for ( ( i = 0; i < length; i++ ) ) ; do
local c = " ${ 1 : i : 1 } "
case $c in
[ a-zA-Z0-9.~_-] )
printf " $c "
; ;
*)
printf '%%%02X' " ' $c "
; ;
esac
done
}
function urlDecode {
2016-10-19 10:28:30 +00:00
local urlEncoded = " ${ 1 //+/ } "
2016-05-26 20:11:00 +00:00
2016-10-19 10:28:30 +00:00
printf '%b' " ${ urlEncoded //%/ \\ x } "
2016-05-26 20:11:00 +00:00
}
2016-10-21 10:37:38 +00:00
## Modified version of http://stackoverflow.com/a/8574392
## Usage: arrayContains "needle" "${haystack[@]}"
arrayContains ( ) {
local e
if [ " $2 " = = "" ] ; then
2016-10-21 13:29:49 +00:00
echo 0 && return 0
2016-10-21 10:37:38 +00:00
fi
for e in " ${ @ : 2 } " ; do
2016-10-21 13:29:49 +00:00
[ [ " $e " = = " $1 " ] ] && echo 1 && return 1
2016-10-21 10:37:38 +00:00
done
2016-10-21 13:29:49 +00:00
echo 0 && return 0
2016-10-21 10:37:38 +00:00
}
2015-11-12 00:37:43 +00:00
function GetLocalOS {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-10-19 10:28:30 +00:00
local localOsVar
2016-02-18 19:54:07 +00:00
2016-11-10 15:16:38 +00:00
# There's no good way to tell if currently running in BusyBox shell. Using sluggish way.
2016-11-14 22:10:37 +00:00
if ls --help 2>& 1 | grep -i "BusyBox" > /dev/null; then
2016-10-22 12:27:08 +00:00
localOsVar = "BusyBox"
2016-11-22 16:41:06 +00:00
# Detecting the special ubuntu userland in Windows 10 bash
elif [ -f /proc/sys/kernel/osrelease ] ; then
localOsVar = " $( cat /proc/sys/kernel/osrelease) "
2016-10-22 12:27:08 +00:00
else
localOsVar = " $( uname -spio 2>& 1) "
2015-11-12 00:37:43 +00:00
if [ $? != 0 ] ; then
2016-10-22 12:27:08 +00:00
localOsVar = " $( uname -v 2>& 1) "
if [ $? != 0 ] ; then
localOsVar = " $( uname) "
fi
2015-11-12 00:37:43 +00:00
fi
fi
2016-10-19 10:28:30 +00:00
case $localOsVar in
2016-11-19 11:37:33 +00:00
# Android uname contains both linux and android, keep it before linux entry
*"Android" *)
LOCAL_OS = "Android"
; ;
2015-11-12 00:37:43 +00:00
*"Linux" *)
LOCAL_OS = "Linux"
; ;
*"BSD" *)
LOCAL_OS = "BSD"
; ;
2016-03-20 15:47:51 +00:00
*"MINGW32" *| *"CYGWIN" *)
2015-11-12 00:37:43 +00:00
LOCAL_OS = "msys"
; ;
2016-11-22 16:41:06 +00:00
*"Microsoft" *)
2016-11-22 16:43:43 +00:00
LOCAL_OS = "WinNT10"
2016-11-22 16:41:06 +00:00
; ;
2015-11-12 00:37:43 +00:00
*"Darwin" *)
LOCAL_OS = "MacOSX"
; ;
2016-10-22 12:27:08 +00:00
*"BusyBox" *)
2016-11-19 11:37:33 +00:00
LOCAL_OS = "BusyBox"
2016-10-22 12:27:08 +00:00
; ;
2015-11-12 00:37:43 +00:00
*)
2016-10-22 12:27:08 +00:00
if [ " $IGNORE_OS_TYPE " = = "yes" ] ; then #TODO(doc): Undocumented option
2016-10-19 10:28:30 +00:00
Logger " Running on unknown local OS [ $localOsVar ]. " "WARN"
2016-03-19 09:48:46 +00:00
return
fi
2016-10-19 10:28:30 +00:00
Logger " Running on >> $localOsVar << not supported. Please report to the author. " "ERROR"
2015-11-12 00:37:43 +00:00
exit 1
; ;
esac
2016-10-19 10:28:30 +00:00
Logger " Local OS: [ $localOsVar ]. " "DEBUG"
2015-11-12 00:37:43 +00:00
}
2016-09-16 08:11:59 +00:00
#### MINIMAL-FUNCTION-SET END ####
2015-11-12 00:37:43 +00:00
function GetRemoteOS {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-11-19 12:13:08 +00:00
if [ " $REMOTE_OPERATION " != "yes" ] ; then
return 0
fi
2016-11-14 22:10:37 +00:00
local remoteOsVar
$SSH_CMD bash -s << 'ENDSSH' >> "$RUN_DIR/$PROGRAM.${FUNCNAME [ 0] } .$SCRIPT_PID " 2>&1
function GetOs {
local localOsVar
# There's no good way to tell if currently running in BusyBox shell. Using sluggish way.
if ls --help 2>& 1 | grep -i "BusyBox" > /dev/null; then
localOsVar = "BusyBox"
2016-11-22 16:41:06 +00:00
elif [ -f /proc/sys/kernel/osrelease ] ; then
localOsVar = " $( cat /proc/sys/kernel/osrelease) "
2016-11-14 22:10:37 +00:00
else
localOsVar = " $( uname -spio 2>& 1) "
if [ $? != 0 ] ; then
localOsVar = " $( uname -v 2>& 1) "
if [ $? != 0 ] ; then
localOsVar = " $( uname) "
fi
fi
fi
echo " $localOsVar "
}
GetOs
ENDSSH
if [ -f " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " ] ; then
remoteOsVar = $( cat " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " )
case $remoteOsVar in
2016-11-19 11:37:33 +00:00
*"Android" *)
REMOTE_OS = "Android"
; ;
2016-11-14 22:10:37 +00:00
*"Linux" *)
REMOTE_OS = "Linux"
; ;
*"BSD" *)
REMOTE_OS = "BSD"
; ;
*"MINGW32" *| *"CYGWIN" *)
REMOTE_OS = "msys"
; ;
2016-11-22 16:41:06 +00:00
*"Microsoft" *)
REMOTE_OS = "WinNT10"
; ;
2016-11-14 22:10:37 +00:00
*"Darwin" *)
REMOTE_OS = "MacOSX"
; ;
*"BusyBox" *)
2016-11-19 11:37:33 +00:00
REMOTE_OS = "BusyBox"
2016-11-14 22:10:37 +00:00
; ;
*"ssh" *| *"SSH" *)
Logger "Cannot connect to remote system." "CRITICAL"
exit 1
; ;
*)
if [ " $IGNORE_OS_TYPE " = = "yes" ] ; then #DOC: Undocumented debug only setting
Logger " Running on unknown remote OS [ $remoteOsVar ]. " "WARN"
return
fi
Logger "Running on remote OS failed. Please report to the author if the OS is not supported." "CRITICAL"
Logger " Remote OS said:\n $remoteOsVar " "CRITICAL"
exit 1
esac
Logger " Remote OS: [ $remoteOsVar ]. " "DEBUG"
else
2016-11-15 12:14:41 +00:00
Logger "Cannot get Remote OS" "CRITICAL"
2015-11-12 00:37:43 +00:00
fi
}
function RunLocalCommand {
local command = " ${ 1 } " # Command to run
2016-10-19 10:28:30 +00:00
local hardMaxTime = " ${ 2 } " # Max time to wait for command to compleet
2016-02-18 19:54:07 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-08-29 11:48:03 +00:00
if [ $_DRYRUN = = true ] ; then
2015-11-12 00:37:43 +00:00
Logger " Dryrun: Local command [ $command ] not run. " "NOTICE"
2015-11-19 21:39:31 +00:00
return 0
2015-11-12 00:37:43 +00:00
fi
2015-11-19 21:39:31 +00:00
2015-11-12 00:37:43 +00:00
Logger " Running command [ $command ] on local host. " "NOTICE"
2016-02-18 19:54:07 +00:00
eval " $command " > " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " 2>& 1 &
2016-10-19 10:28:30 +00:00
WaitForTaskCompletion $! 0 $hardMaxTime ${ FUNCNAME [0] } true $KEEP_LOGGING
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval -eq 0 ] ; then
Logger "Command succeded." "NOTICE"
else
Logger "Command failed." "ERROR"
fi
2016-11-17 19:00:23 +00:00
if [ $_LOGGER_VERBOSE = = true ] || [ $retval -ne 0 ] ; then
2016-02-18 19:54:07 +00:00
Logger " Command output:\n $( cat $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID ) " "NOTICE"
2015-11-12 00:37:43 +00:00
fi
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ] ; then
Logger "Stopping on command execution error." "CRITICAL"
exit 1
fi
}
## Runs remote command $1 and waits for completition in $2 seconds
function RunRemoteCommand {
local command = " ${ 1 } " # Command to run
2016-10-19 10:28:30 +00:00
local hardMaxTime = " ${ 2 } " # Max time to wait for command to compleet
2016-02-18 19:54:07 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
CheckConnectivity3rdPartyHosts
CheckConnectivityRemoteHost
2016-08-29 11:48:03 +00:00
if [ $_DRYRUN = = true ] ; then
2015-11-12 00:37:43 +00:00
Logger " Dryrun: Local command [ $command ] not run. " "NOTICE"
2015-11-19 21:39:31 +00:00
return 0
2015-11-12 00:37:43 +00:00
fi
2015-11-19 21:39:31 +00:00
2015-11-12 00:37:43 +00:00
Logger " Running command [ $command ] on remote host. " "NOTICE"
2016-02-18 19:54:07 +00:00
cmd = $SSH_CMD ' "$command" > "' $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID '" 2>&1'
2015-11-12 00:37:43 +00:00
Logger " cmd: $cmd " "DEBUG"
eval " $cmd " &
2016-10-19 10:28:30 +00:00
WaitForTaskCompletion $! 0 $hardMaxTime ${ FUNCNAME [0] } true $KEEP_LOGGING
2015-11-12 00:37:43 +00:00
retval = $?
if [ $retval -eq 0 ] ; then
Logger "Command succeded." "NOTICE"
else
Logger "Command failed." "ERROR"
fi
2016-11-17 19:00:23 +00:00
if [ -f " $RUN_DIR / $PROGRAM . ${ FUNCNAME [0] } . $SCRIPT_PID " ] && ( [ $_LOGGER_VERBOSE = = true ] || [ $retval -ne 0 ] )
2015-11-12 00:37:43 +00:00
then
2016-02-18 19:54:07 +00:00
Logger " Command output:\n $( cat $RUN_DIR /$PROGRAM .${ FUNCNAME [0] } .$SCRIPT_PID ) " "NOTICE"
2015-11-12 00:37:43 +00:00
fi
if [ " $STOP_ON_CMD_ERROR " = = "yes" ] && [ $retval -ne 0 ] ; then
Logger "Stopping on command execution error." "CRITICAL"
exit 1
fi
}
function RunBeforeHook {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-10-19 10:28:30 +00:00
local pids
2016-08-03 22:52:05 +00:00
2015-11-12 00:37:43 +00:00
if [ " $LOCAL_RUN_BEFORE_CMD " != "" ] ; then
2016-08-03 22:28:09 +00:00
RunLocalCommand " $LOCAL_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE &
pids = " $! "
2015-11-12 00:37:43 +00:00
fi
if [ " $REMOTE_RUN_BEFORE_CMD " != "" ] ; then
2016-08-03 22:28:09 +00:00
RunRemoteCommand " $REMOTE_RUN_BEFORE_CMD " $MAX_EXEC_TIME_PER_CMD_BEFORE &
pids = " $pids ; $! "
2015-11-12 00:37:43 +00:00
fi
2016-08-03 22:52:05 +00:00
if [ " $pids " != "" ] ; then
2016-08-18 21:28:41 +00:00
WaitForTaskCompletion $pids 0 0 ${ FUNCNAME [0] } true $KEEP_LOGGING
2016-08-03 22:52:05 +00:00
fi
2015-11-12 00:37:43 +00:00
}
function RunAfterHook {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-08-03 22:52:05 +00:00
local pids
2015-11-12 00:37:43 +00:00
if [ " $LOCAL_RUN_AFTER_CMD " != "" ] ; then
2016-08-03 22:28:09 +00:00
RunLocalCommand " $LOCAL_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER &
pids = " $! "
2015-11-12 00:37:43 +00:00
fi
if [ " $REMOTE_RUN_AFTER_CMD " != "" ] ; then
2016-08-03 22:28:09 +00:00
RunRemoteCommand " $REMOTE_RUN_AFTER_CMD " $MAX_EXEC_TIME_PER_CMD_AFTER &
pids = " $pids ; $! "
2015-11-12 00:37:43 +00:00
fi
2016-08-03 22:52:05 +00:00
if [ " $pids " != "" ] ; then
2016-08-18 21:28:41 +00:00
WaitForTaskCompletion $pids 0 0 ${ FUNCNAME [0] } true $KEEP_LOGGING
2016-08-03 22:52:05 +00:00
fi
2015-11-12 00:37:43 +00:00
}
function CheckConnectivityRemoteHost {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-09-05 20:06:57 +00:00
local retval
2016-11-20 16:43:13 +00:00
if [ " $_PARANOIA_DEBUG " != "yes" ] ; then # Do not loose time in paranoia debug #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ " $REMOTE_HOST_PING " != "no" ] && [ " $REMOTE_OPERATION " != "no" ] ; then
eval " $PING_CMD $REMOTE_HOST > /dev/null 2>&1 " &
2016-08-28 09:32:25 +00:00
WaitForTaskCompletion $! 60 180 ${ FUNCNAME [0] } true $KEEP_LOGGING
2016-09-05 20:06:57 +00:00
retval = $?
if [ $retval != 0 ] ; then
2016-09-16 08:11:59 +00:00
Logger " Cannot ping [ $REMOTE_HOST ]. Return code [ $retval ]. " "WARN"
2016-09-05 20:06:57 +00:00
return $retval
2015-11-12 00:37:43 +00:00
fi
fi
2016-11-20 16:43:13 +00:00
fi #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
}
function CheckConnectivity3rdPartyHosts {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-10-19 10:28:30 +00:00
local remote3rdPartySuccess
2016-09-05 20:06:57 +00:00
local retval
2016-08-08 16:06:31 +00:00
2016-11-20 16:43:13 +00:00
if [ " $_PARANOIA_DEBUG " != "yes" ] ; then # Do not loose time in paranoia debug #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
if [ " $REMOTE_3RD_PARTY_HOSTS " != "" ] ; then
2016-10-19 10:28:30 +00:00
remote3rdPartySuccess = false
2015-11-12 00:37:43 +00:00
for i in $REMOTE_3RD_PARTY_HOSTS
do
eval " $PING_CMD $i > /dev/null 2>&1 " &
2016-08-19 09:09:07 +00:00
WaitForTaskCompletion $! 180 360 ${ FUNCNAME [0] } true $KEEP_LOGGING
2016-09-05 20:06:57 +00:00
retval = $?
if [ $retval != 0 ] ; then
Logger " Cannot ping 3rd party host [ $i ]. Return code [ $retval ]. " "NOTICE"
2015-11-12 00:37:43 +00:00
else
2016-10-19 10:28:30 +00:00
remote3rdPartySuccess = true
2015-11-12 00:37:43 +00:00
fi
done
2016-08-08 16:06:31 +00:00
2016-10-19 10:28:30 +00:00
if [ $remote3rdPartySuccess = = false ] ; then
2016-09-16 08:11:59 +00:00
Logger "No remote 3rd party host responded to ping. No internet ?" "WARN"
2015-11-12 00:37:43 +00:00
return 1
2016-08-08 16:06:31 +00:00
else
return 0
2015-11-12 00:37:43 +00:00
fi
fi
2016-11-20 16:43:13 +00:00
fi #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
}
#__BEGIN_WITH_PARANOIA_DEBUG
function __CheckArguments {
# Checks the number of arguments of a function and raises an error if some are missing
if [ " $_DEBUG " = = "yes" ] ; then
2016-08-28 09:32:25 +00:00
local numberOfArguments = " ${ 1 } " # Number of arguments the tested function should have, can be a number of a range, eg 0-2 for zero to two arguments
local numberOfGivenArguments = " ${ 2 } " # Number of arguments that have been passed
local functionName = " ${ 3 } " # Function name that called __CheckArguments
local minArgs
local maxArgs
2015-11-12 00:37:43 +00:00
if [ " $_PARANOIA_DEBUG " = = "yes" ] ; then
2016-08-28 09:32:25 +00:00
Logger " Entering function [ $functionName ]. " "DEBUG"
2015-11-12 00:37:43 +00:00
fi
2016-08-08 16:06:31 +00:00
# All arguments of the function to check are passed as array in ${4} (the function call waits for $@)
# If any of the arguments contains spaces, bash things there are two aguments
# In order to avoid this, we need to iterate over ${4} and count
local iterate = 4
2016-08-29 11:48:03 +00:00
local fetchArguments = true
2016-08-28 09:32:25 +00:00
local argList = ""
local countedArguments
2016-08-29 11:48:03 +00:00
while [ $fetchArguments = = true ] ; do
2016-08-08 16:06:31 +00:00
cmd = 'argument=${' $iterate '}'
eval $cmd
if [ " $argument " = "" ] ; then
2016-08-29 11:48:03 +00:00
fetchArguments = false
2016-08-08 16:06:31 +00:00
else
2016-08-28 09:32:25 +00:00
argList = " $arg_list [Argument $(( $iterate - 3 )) : $argument ] "
2016-08-08 16:06:31 +00:00
iterate = $(( $iterate + 1 ))
fi
done
2016-08-28 09:32:25 +00:00
countedArguments = $(( iterate-4))
if [ $( IsNumeric " $numberOfArguments " ) -eq 1 ] ; then
minArgs = $numberOfArguments
maxArgs = $numberOfArguments
else
IFS = '-' read minArgs maxArgs <<< " $numberOfArguments "
fi
2016-08-08 16:06:31 +00:00
2016-08-28 09:32:25 +00:00
if ! ( [ $countedArguments -ge $minArgs ] && [ $countedArguments -le $maxArgs ] ) ; then
Logger " Function $functionName may have inconsistent number of arguments. Expected min: $minArgs , max: $maxArgs , count: $countedArguments , bash seen: $numberOfGivenArguments . see log file. " "ERROR"
Logger " Arguments passed: $argList " "ERROR"
2016-08-08 16:06:31 +00:00
fi
2015-11-12 00:37:43 +00:00
fi
}
2016-02-21 10:12:41 +00:00
#__END_WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
function RsyncPatternsAdd {
2016-10-19 10:28:30 +00:00
local patternType = " ${ 1 } " # exclude or include
2016-04-01 19:29:33 +00:00
local pattern = " ${ 2 } "
2016-02-21 10:12:41 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-08-08 16:06:31 +00:00
local rest
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
# Disable globbing so wildcards from exclusions do not get expanded
set -f
rest = " $pattern "
while [ -n " $rest " ]
do
# Take the string until first occurence until $PATH_SEPARATOR_CHAR
2016-10-19 10:28:30 +00:00
str = ${ rest %%;* } #TODO: replace ; with $PATH_SEPARATOR_CHAR
2016-02-21 10:12:41 +00:00
# Handle the last case
if [ " $rest " = " ${ rest / $PATH_SEPARATOR_CHAR / } " ] ; then
rest =
else
# Cut everything before the first occurence of $PATH_SEPARATOR_CHAR
rest = ${ rest #* $PATH_SEPARATOR_CHAR }
2015-11-12 00:37:43 +00:00
fi
2016-02-21 10:12:41 +00:00
if [ " $RSYNC_PATTERNS " = = "" ] ; then
2016-10-19 10:28:30 +00:00
RSYNC_PATTERNS = "--" $patternType " =\" $str \" "
2016-02-21 10:12:41 +00:00
else
2016-10-19 10:28:30 +00:00
RSYNC_PATTERNS = " $RSYNC_PATTERNS -- " $patternType " =\" $str \" "
2015-11-12 00:37:43 +00:00
fi
2016-02-21 10:12:41 +00:00
done
set +f
}
2015-11-12 00:37:43 +00:00
2016-02-21 10:12:41 +00:00
function RsyncPatternsFromAdd {
2016-10-19 10:28:30 +00:00
local patternType = " ${ 1 } "
local patternFrom = " ${ 2 } "
2016-02-21 10:12:41 +00:00
__CheckArguments 2 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2016-08-08 16:06:31 +00:00
## Check if the exclude list has a full path, and if not, add the config file path if there is one
2016-10-19 10:28:30 +00:00
if [ " $( basename $patternFrom ) " = = " $patternFrom " ] ; then
patternFrom = " $( dirname $CONFIG_FILE ) / $patternFrom "
2016-08-08 16:06:31 +00:00
fi
2016-02-21 10:12:41 +00:00
2016-10-19 10:28:30 +00:00
if [ -e " $patternFrom " ] ; then
RSYNC_PATTERNS = " $RSYNC_PATTERNS -- " $patternType " -from=\" $patternFrom \" "
2016-08-08 16:06:31 +00:00
fi
2016-02-21 10:12:41 +00:00
}
function RsyncPatterns {
2016-08-08 16:06:31 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
if [ " $RSYNC_PATTERN_FIRST " = = "exclude" ] ; then
if [ " $RSYNC_EXCLUDE_PATTERN " != "" ] ; then
RsyncPatternsAdd "exclude" " $RSYNC_EXCLUDE_PATTERN "
fi
if [ " $RSYNC_EXCLUDE_FROM " != "" ] ; then
RsyncPatternsFromAdd "exclude" " $RSYNC_EXCLUDE_FROM "
fi
if [ " $RSYNC_INCLUDE_PATTERN " != "" ] ; then
RsyncPatternsAdd " $RSYNC_INCLUDE_PATTERN " "include"
fi
if [ " $RSYNC_INCLUDE_FROM " != "" ] ; then
RsyncPatternsFromAdd "include" " $RSYNC_INCLUDE_FROM "
fi
2016-09-16 08:11:59 +00:00
# Use default include first for quicksync runs
2016-10-23 16:23:44 +00:00
elif [ " $RSYNC_PATTERN_FIRST " = = "include" ] || [ " $_QUICK_SYNC " = = "2" ] ; then
2016-08-08 16:06:31 +00:00
if [ " $RSYNC_INCLUDE_PATTERN " != "" ] ; then
RsyncPatternsAdd "include" " $RSYNC_INCLUDE_PATTERN "
fi
if [ " $RSYNC_INCLUDE_FROM " != "" ] ; then
RsyncPatternsFromAdd "include" " $RSYNC_INCLUDE_FROM "
fi
if [ " $RSYNC_EXCLUDE_PATTERN " != "" ] ; then
RsyncPatternsAdd "exclude" " $RSYNC_EXCLUDE_PATTERN "
fi
if [ " $RSYNC_EXCLUDE_FROM " != "" ] ; then
RsyncPatternsFromAdd "exclude" " $RSYNC_EXCLUDE_FROM "
fi
else
Logger "Bogus RSYNC_PATTERN_FIRST value in config file. Will not use rsync patterns." "WARN"
fi
2015-11-12 00:37:43 +00:00
}
function PreInit {
2016-02-18 19:54:07 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
2016-10-23 16:23:44 +00:00
local compressionString
2015-11-12 00:37:43 +00:00
## SSH compression
2016-08-08 16:06:31 +00:00
if [ " $SSH_COMPRESSION " != "no" ] ; then
SSH_COMP = -C
else
SSH_COMP =
fi
2015-11-12 00:37:43 +00:00
2016-03-29 20:55:57 +00:00
## Ignore SSH known host verification
if [ " $SSH_IGNORE_KNOWN_HOSTS " = = "yes" ] ; then
SSH_OPTS = "-o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no"
fi
2016-08-08 16:06:31 +00:00
## Support for older config files without RSYNC_EXECUTABLE option
if [ " $RSYNC_EXECUTABLE " = = "" ] ; then
RSYNC_EXECUTABLE = rsync
fi
## Sudo execution option
if [ " $SUDO_EXEC " = = "yes" ] ; then
if [ " $RSYNC_REMOTE_PATH " != "" ] ; then
RSYNC_PATH = " sudo $RSYNC_REMOTE_PATH / $RSYNC_EXECUTABLE "
else
RSYNC_PATH = " sudo $RSYNC_EXECUTABLE "
fi
COMMAND_SUDO = "sudo"
else
if [ " $RSYNC_REMOTE_PATH " != "" ] ; then
RSYNC_PATH = " $RSYNC_REMOTE_PATH / $RSYNC_EXECUTABLE "
else
RSYNC_PATH = " $RSYNC_EXECUTABLE "
fi
COMMAND_SUDO = ""
fi
2015-11-12 00:37:43 +00:00
2016-11-21 14:13:15 +00:00
## Set compression executable and extension
2016-10-23 16:23:44 +00:00
if [ " $( IsInteger $COMPRESSION_LEVEL ) " -eq 0 ] ; then
COMPRESSION_LEVEL = 3
fi
2016-11-21 14:13:15 +00:00
#TODO: Remote OS isn't defined yet
2016-10-23 16:23:44 +00:00
## Busybox fix (Termux xz command doesn't support compression at all)
2016-11-19 11:37:33 +00:00
if [ " $LOCAL_OS " = = "BusyBox" ] || [ " $REMOTE_OS " = = "Busybox" ] || [ " $LOCAL_OS " = = "Android" ] || [ " $REMOTE_OS " = = "Android" ] ; then
2016-10-23 16:23:44 +00:00
compressionString = ""
if type gzip > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | gzip -c $compressionString "
COMPRESSION_EXTENSION = .gz
# obackup specific
else
COMPRESSION_PROGRAM =
COMPRESSION_EXTENSION =
fi
2016-08-08 16:06:31 +00:00
else
2016-10-23 16:23:44 +00:00
compressionString = " - $COMPRESSION_LEVEL "
if type xz > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | xz -c $compressionString "
COMPRESSION_EXTENSION = .xz
elif type lzma > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | lzma -c $compressionString "
COMPRESSION_EXTENSION = .lzma
elif type pigz > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | pigz -c $compressionString "
COMPRESSION_EXTENSION = .gz
# obackup specific
COMPRESSION_OPTIONS = --rsyncable
elif type gzip > /dev/null 2>& 1
then
COMPRESSION_PROGRAM = " | gzip -c $compressionString "
COMPRESSION_EXTENSION = .gz
# obackup specific
COMPRESSION_OPTIONS = --rsyncable
else
COMPRESSION_PROGRAM =
COMPRESSION_EXTENSION =
fi
2016-08-08 16:06:31 +00:00
fi
ALERT_LOG_FILE = " $ALERT_LOG_FILE $COMPRESSION_EXTENSION "
2015-11-12 00:37:43 +00:00
}
function PostInit {
2016-08-08 16:06:31 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
2015-11-12 00:37:43 +00:00
# Define remote commands
2016-10-19 10:28:30 +00:00
if [ -f " $SSH_RSA_PRIVATE_KEY " ] ; then
SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY $SSH_OPTS $REMOTE_USER @ $REMOTE_HOST -p $REMOTE_PORT "
SCP_CMD = " $( type -p scp) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY -P $REMOTE_PORT "
RSYNC_SSH_CMD = " $( type -p ssh) $SSH_COMP -i $SSH_RSA_PRIVATE_KEY $SSH_OPTS -p $REMOTE_PORT "
elif [ -f " $SSH_PASSWORD_FILE " ] ; then
SSH_CMD = " $( type -p sshpass) -f $SSH_PASSWORD_FILE $( type -p ssh) $SSH_COMP $SSH_OPTS $REMOTE_USER @ $REMOTE_HOST -p $REMOTE_PORT "
SCP_CMD = " $( type -p sshpass) -f $SSH_PASSWORD_FILE $( type -p scp) $SSH_COMP -P $REMOTE_PORT "
RSYNC_SSH_CMD = " $( type -p sshpass) -f $SSH_PASSWORD_FILE $( type -p ssh) $SSH_COMP $SSH_OPTS -p $REMOTE_PORT "
else
SSH_PASSWORD = ""
SSH_CMD = ""
SCP_CMD = ""
RSYNC_SSH_CMD = ""
fi
2015-11-12 00:37:43 +00:00
}
function InitLocalOSSettings {
2016-08-08 16:06:31 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
## If running under Msys, some commands do not run the same way
## Using mingw version of find instead of windows one
## Getting running processes is quite different
## Ping command is not the same
if [ " $LOCAL_OS " = = "msys" ] ; then
FIND_CMD = $( dirname $BASH ) /find
PING_CMD = '$SYSTEMROOT\system32\ping -n 2'
else
FIND_CMD = find
PING_CMD = "ping -c 2 -i .2"
fi
2016-11-22 17:18:35 +00:00
if [ " $LOCAL_OS " = = "BusyBox" ] || [ " $LOCAL_OS " = = "Android" ] || [ " $LOCAL_OS " = = "msys" ] ; then
2016-10-22 12:14:52 +00:00
PROCESS_STATE_CMD = "echo none"
2016-11-19 11:37:33 +00:00
DF_CMD = "df"
2016-10-22 12:14:52 +00:00
else
PROCESS_STATE_CMD = 'ps -p$pid -o state= 2 > /dev/null'
2016-11-19 11:37:33 +00:00
# CentOS 5 needs -P for one line output
DF_CMD = "df -P"
2016-10-22 12:14:52 +00:00
fi
2016-08-08 16:06:31 +00:00
## Stat command has different syntax on Linux and FreeBSD/MacOSX
if [ " $LOCAL_OS " = = "MacOSX" ] || [ " $LOCAL_OS " = = "BSD" ] ; then
2016-10-22 12:27:08 +00:00
# Tested on BSD and Mac
2016-08-08 16:06:31 +00:00
STAT_CMD = "stat -f \"%Sm\""
2016-04-03 14:06:45 +00:00
STAT_CTIME_MTIME_CMD = "stat -f %N;%c;%m"
2016-08-08 16:06:31 +00:00
else
2016-11-22 17:18:35 +00:00
# Tested on GNU stat, busybox and Cygwin
2016-10-22 12:27:08 +00:00
STAT_CMD = "stat -c %y"
2016-04-03 14:06:45 +00:00
STAT_CTIME_MTIME_CMD = "stat -c %n;%Z;%Y"
2016-08-08 16:06:31 +00:00
fi
2015-11-12 00:37:43 +00:00
}
function InitRemoteOSSettings {
2016-08-08 16:06:31 +00:00
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
if [ " $REMOTE_OS " = = "msys" ] ; then
REMOTE_FIND_CMD = $( dirname $BASH ) /find
else
REMOTE_FIND_CMD = find
fi
## Stat command has different syntax on Linux and FreeBSD/MacOSX
if [ " $LOCAL_OS " = = "MacOSX" ] || [ " $LOCAL_OS " = = "BSD" ] ; then
REMOTE_STAT_CMD = "stat -f \"%Sm\""
2016-04-03 14:06:45 +00:00
REMOTE_STAT_CTIME_MTIME_CMD = "stat -f \\\"%N;%c;%m\\\""
2016-08-08 16:06:31 +00:00
else
REMOTE_STAT_CMD = "stat --format %y"
2016-04-03 14:06:45 +00:00
REMOTE_STAT_CTIME_MTIME_CMD = "stat -c \\\"%n;%Z;%Y\\\""
2016-08-08 16:06:31 +00:00
fi
2016-04-03 14:06:45 +00:00
2015-11-12 00:37:43 +00:00
}
2016-11-21 14:13:15 +00:00
function InitRsyncSettings {
__CheckArguments 0 $# ${ FUNCNAME [0] } " $@ " #__WITH_PARANOIA_DEBUG
## Set rsync default arguments
RSYNC_ARGS = "-rltD"
if [ " $_DRYRUN " = = true ] ; then
RSYNC_DRY_ARG = "-n"
DRY_WARNING = "/!\ DRY RUN "
else
RSYNC_DRY_ARG = ""
fi
RSYNC_ATTR_ARGS = ""
if [ " $PRESERVE_PERMISSIONS " != "no" ] ; then
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -p"
fi
if [ " $PRESERVE_OWNER " != "no" ] ; then
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -o"
fi
if [ " $PRESERVE_GROUP " != "no" ] ; then
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -g"
fi
if [ " $PRESERVE_EXECUTABILITY " != "no" ] ; then
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " --executability"
fi
if [ " $LOCAL_OS " != "MacOSX" ] && [ " $REMOTE_OS " != "MacOSX" ] ; then
if [ " $PRESERVE_ACL " = = "yes" ] ; then
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -A"
fi
if [ " $PRESERVE_XATTR " = = "yes" ] ; then
RSYNC_ATTR_ARGS = $RSYNC_ATTR_ARGS " -X"
fi
fi
if [ " $RSYNC_COMPRESS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -z"
fi
if [ " $COPY_SYMLINKS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -L"
fi
if [ " $KEEP_DIRLINKS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -K"
fi
if [ " $PRESERVE_HARDLINKS " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " -H"
fi
if [ " $CHECKSUM " = = "yes" ] ; then
RSYNC_TYPE_ARGS = $RSYNC_TYPE_ARGS " --checksum"
fi
if [ " $BANDWIDTH " != "" ] && [ " $BANDWIDTH " != "0" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " --bwlimit= $BANDWIDTH "
fi
if [ " $PARTIAL " = = "yes" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " --partial --partial-dir=\" $PARTIAL_DIR \" "
RSYNC_PARTIAL_EXCLUDE = " --exclude=\" $PARTIAL_DIR \" "
fi
if [ " $DELTA_COPIES " != "no" ] ; then
RSYNC_ARGS = $RSYNC_ARGS " --no-whole-file"
else
RSYNC_ARGS = $RSYNC_ARGS " --whole-file"
fi
}
2016-08-18 21:28:41 +00:00
## IFS debug function
function PrintIFS {
printf "IFS is: %q" " $IFS "
}
2016-09-16 08:11:59 +00:00
# Process debugging
# Recursive function to get all parents from a pid
function ParentPid {
local pid = " ${ 1 } " # Pid to analyse
local parent
parent = $( ps -p $pid -o ppid = )
echo " $pid is a child of $parent "
if [ $parent -gt 0 ] ; then
ParentPid $parent
fi
}
2015-11-12 00:37:43 +00:00
## END Generic functions